/*
File: ControlAppThreadIn.java
Date		Author		Changes
Sep 09 96	Lukasz Beca	Created
*/


package webwisdom.tango.interfaces;

import java.applet.Applet;
import webwisdom.tango.messages.Message;
import webwisdom.tango.main.LocalBase;
import webwisdom.tango.structures.ControlApplication;
import netscape.javascript.JSObject;
import webwisdom.tango.consts.Const;

public abstract class ControlAppletBase extends Applet {

  private ControlApplication ca;
  
  public int register(){
    
    LocalBase p;

    p = getPlugin();
    if (p == null) {
      System.out.println("ControlAppletBase: register failed, terminating applet");
      destroy();
      return Const.OK;
    }
      
    ca = p.reg.registerCA(this);
    System.out.println("ControlAppletBase: CA registered, terminating applet");  
	  
	  return ca.getStatus();    
  }

  public void sendServer(Message m) {    
    
    if (ca != null) 
      ca.sendCABToCS(m);
  }

  public void sendApp(int AID, Message m) {

    if (ca != null) 
      ca.sendCABToApp(AID, m);
  }

  public void finish(int AID) {

    if (ca != null)
      ca.finish(AID);  
  }

  public void logout() {

    if (ca != null)
      ca.logout();
  }
  
  public String getServer() {
  
  	return ca.getServerHost();
  }

  public boolean appExists(int AID) { //check if application is added to plugin structures
    boolean result;

    if (ca != null) 
      result = ca.appExists(AID);
    else
      result = false;

    return result;
  }


//  public void startApplet(String url, int AID, String height, String width) {

//    if (ca != null)    
//      ca.startApplet(url, AID, height, width); 
//  }

	//prototype method
	
	public void startApplet(String url, int AID, int SID, int AT, String height, String width) {

    if (ca != null)    
      ca.startApplet(url, AID, SID, AT, height, width); 
  }
	
	//end of prototype method


  //applet in frame

  public void startApplet(String url, int AID, int SID, int AT, String framename) {

   // if (ca != null)
   //   ca.startApplet(url, AID, framename);
  }

  //applet in frame


 // public void startApplication(int AT, int AID) {

 //   if (ca != null) 
 //     ca.startApplication(AT, AID);
 //}

  public void startApplication(int AID, int SID, int AT) {

    if (ca != null) {
    
      String path = getApplicationPath(AT);
      ca.startApplication(path, AID, SID, AT);
    }
      
  }

  public synchronized abstract void receiveServer(Message m);


  public synchronized abstract void receiveApp(int AID, Message m);
  
  public synchronized abstract void addApplication(int AID, int SID, int AT);
  
  public abstract String getApplicationPath(int AT);

  public abstract void removeApplication(int AID);  //new method, control application notified about end of application

	public synchronized abstract void error(int errorCode);

  public void setFocus(int AID) {

    if (ca != null)
      ca.setFocus(AID);   
  }


  private LocalBase getPlugin() {

    JSObject tmp, parent, frame, win; 
      
    win = (JSObject) JSObject.getWindow(this);
    if (win == null) {
      System.out.println("ControlAppletBase: unable to get reference to window");	
      return null;
    }

    parent = (JSObject) win.getMember("parent");
     if (parent == null) {
       System.out.println("ControlAppletBase: unable to get reference to parent");
       return null;
     }
  
    frame = (JSObject) parent.getMember("navbar");
    if (frame == null) {
       System.out.println("ControlAppletBase: unable to get reference to frame");
       return null;
    }

    tmp = (JSObject) frame.getMember("document");
    if (tmp == null) {
      System.out.println("ControlAppletBase: unable to get reference to document");
      return null;
    }
	
    return (LocalBase) tmp.getMember("local");
  }
}












